- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ bluemind_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ bluemind_name }}-to-{{ ldap_name | default('ldap') }}"
    policy_namespace: "{{ ldap_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_ldap)
                                else 'absent' }}"
    subject: "{{ ldap_name | default('ldap') }}"
    to:
    - number: "1389"
    - number: "1636"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ bluemind_name }}"
      namespace: "{{ namespace }}"
    policy_name: "{{ bluemind_name }}-to-{{ lemon_name | default('lemon') }}"
    policy_namespace: "{{ ldap_namespace | default(namespace) }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_lemon)
                                else 'absent' }}"
    subject: "{{ lemon_name | default('lemon') }}"
    to:
    - number: "8080"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ bluemind_name }}"
    policy_name: "{{ bluemind_name }}-to-{{ orange_name | default('orange') }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_orange)
                                else 'absent' }}"
    subject: "{{ orange_name | default('orange') }}"
    to:
    - number: "1783"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ bluemind_name }}"
    policy_name: "{{ bluemind_name }}-to-{{ rspamd_name | default('rspamd') }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_rspamd)
                                else 'absent' }}"
    subject: "{{ rspamd_name | default('rspamd') }}"
    to:
    - number: "11332"
- include_role:
    name: commons
    tasks_from: helpers/datavolume.yaml
  vars:
    dv_name: "{{ bluemind_name }}-rootfs"
    dv_size: 20Gi
    dv_source: "{{ bluemind_image_source }}"
- include_role:
    name: commons
    tasks_from: helpers/volume.yaml
  loop:
  - { sfx: backups, capacity: "{{ bluemind_backups_data_capacity }}" }
  - { sfx: cyrus, capacity: "{{ bluemind_cyrus_data_capacity }}" }
  - { sfx: hsm, capacity: "{{ bluemind_hsm_data_capacity }}" }
  - { sfx: logs, capacity: "{{ bluemind_logs_data_capacity }}" }
  - { sfx: psql, capacity: "{{ bluemind_psql_data_capacity }}" }
  - { sfx: swap, capacity: "{{ bluemind_swap_data_capacity }}" }
  loop_control:
    label: "{{ l.sfx }}"
    loop_var: l
  vars:
    vol_name: "{{ bluemind_name }}-{{ l.sfx }}"
    vol_size: "{{ l.capacity }}"
    vol_state: "{{ 'present' if (l.capacity != False)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/configmap.yaml
  vars:
    cm_name: "{{ bluemind_name }}"
    files:
    - name: context.conf
      data: "{{ lookup('template', 'bm-context.j2') }}"
- name: Lookups BlueMind VirtualMachine
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: kubevirt.io/v1alpha3
    kind: VirtualMachine
    name: "{{ bluemind_name }}"
    namespace: "{{ namespace }}"
  no_log: True
  poll: 5
  register: has_vm
- name: Installs BlueMind VirtualMachine
  async: 30
  k8s:
    definition: "{{ lookup('template', 'bluemind.j2') }}"
  poll: 5
  register: bm_created
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 22
    - 24
    - 25
    - 80
    - 81
    - 110
    - 111
    - 143
    - 443
    - 465
    - 587
    - 993
    - 995
    - 1110
    - 1143
    - 2000
    - 2400
    - 2500
    - 2501
    - 2502
    - 5222
    - 5223
    - 5269
    - 5280
    - 5290
    - 5432
    - 5701
    - 5702
    - 5703
    - 8022
    - 8079
    - 8080
    - 8082
    - 8084
    - 8086
    - 8087
    - 8090
    - 8888
    - 9092
    - 9200
    - 9300
    svc_name: "{{ bluemind_name }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ bluemind_name }}"
    policy_state: "{{ 'present' if (do_network_policy)
                                else 'absent' }}"
    subject: "{{ bluemind_name }}"
    to:
    - number: "22"
    - number: "24"
    - number: "25"
    - number: "80"
    - number: "81"
    - number: "110"
    - number: "111"
    - number: "143"
    - number: "443"
    - number: "465"
    - number: "587"
    - number: "993"
    - number: "995"
    - number: "1110"
    - number: "1143"
    - number: "2000"
    - number: "2400"
    - number: "2500"
    - number: "2501"
    - number: "2502"
    - number: "5222"
    - number: "5223"
    - number: "5269"
    - number: "5280"
    - number: "5290"
    - number: "5432"
    - number: "5701"
    - number: "5702"
    - number: "5703"
    - number: "8022"
    - number: "8079"
    - number: "8080"
    - number: "8082"
    - number: "8084"
    - number: "8086"
    - number: "8087"
    - number: "8090"
    - number: "8888"
    - number: "9092"
    - number: "9200"
    - number: "9300"
# TODO / FIXME
# I would assume there's a way to create a VirtualMachineInstance out of our
# VirtualMachine using ansibles' k8s plugin / docs focuses on virtctl start
# ... to check ...
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    is_exporter: True
    ports:
    - 9154
    - 9273
    svc_name: "{{ bluemind_name }}"
    svc_state: "{{ 'present' if (do_exporters)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ prometheus_namespace_match }}"
    policy_name: "prometheus-to-{{ bluemind_name }}"
    policy_state: "{{ 'present' if (do_exporters
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ bluemind_name }}"
    to:
    - number: "9154"
    - number: "9273"
- include_role:
    name: commons
    tasks_from: helpers/route.yaml
  vars:
    route_custom_timeout: 2m
    route_host: "{{ bluemind_fqdn }}"
    route_name: "{{ bluemind_name }}"
    route_tls_termination: passthrough
# BM cert is auto-signed, can't use re-encrypt if haproxy does not know of that CA, unless adding some option to ingress controllers ...
# in our case, OCP is behind a RP using LE certs, we don't really care which cert is exposed by OCP routers anyway
    svc_name: "{{ bluemind_name }}"
